// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from caret_msgs:msg/Status.idl
// generated code does not contain a copyright notice

#ifndef CARET_MSGS__MSG__DETAIL__STATUS__STRUCT_HPP_
#define CARET_MSGS__MSG__DETAIL__STATUS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__caret_msgs__msg__Status __attribute__((deprecated))
#else
# define DEPRECATED__caret_msgs__msg__Status __declspec(deprecated)
#endif

namespace caret_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct Status_
{
  using Type = Status_<ContainerAllocator>;

  explicit Status_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->caret_node_name = "";
      this->status = 0;
      this->pid = 0ll;
    }
  }

  explicit Status_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : caret_node_name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->caret_node_name = "";
      this->status = 0;
      this->pid = 0ll;
    }
  }

  // field types and members
  using _caret_node_name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _caret_node_name_type caret_node_name;
  using _status_type =
    int8_t;
  _status_type status;
  using _node_names_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>>;
  _node_names_type node_names;
  using _pid_type =
    int64_t;
  _pid_type pid;

  // setters for named parameter idiom
  Type & set__caret_node_name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->caret_node_name = _arg;
    return *this;
  }
  Type & set__status(
    const int8_t & _arg)
  {
    this->status = _arg;
    return *this;
  }
  Type & set__node_names(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>> & _arg)
  {
    this->node_names = _arg;
    return *this;
  }
  Type & set__pid(
    const int64_t & _arg)
  {
    this->pid = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int8_t UNINITIALIZED =
    0;
  static constexpr int8_t WAIT =
    1;
  static constexpr int8_t PREPARE =
    2;
  static constexpr int8_t RECORD =
    3;

  // pointer types
  using RawPtr =
    caret_msgs::msg::Status_<ContainerAllocator> *;
  using ConstRawPtr =
    const caret_msgs::msg::Status_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<caret_msgs::msg::Status_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<caret_msgs::msg::Status_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      caret_msgs::msg::Status_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<caret_msgs::msg::Status_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      caret_msgs::msg::Status_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<caret_msgs::msg::Status_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<caret_msgs::msg::Status_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<caret_msgs::msg::Status_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__caret_msgs__msg__Status
    std::shared_ptr<caret_msgs::msg::Status_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__caret_msgs__msg__Status
    std::shared_ptr<caret_msgs::msg::Status_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const Status_ & other) const
  {
    if (this->caret_node_name != other.caret_node_name) {
      return false;
    }
    if (this->status != other.status) {
      return false;
    }
    if (this->node_names != other.node_names) {
      return false;
    }
    if (this->pid != other.pid) {
      return false;
    }
    return true;
  }
  bool operator!=(const Status_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct Status_

// alias to use template instance with default allocator
using Status =
  caret_msgs::msg::Status_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t Status_<ContainerAllocator>::UNINITIALIZED;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t Status_<ContainerAllocator>::WAIT;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t Status_<ContainerAllocator>::PREPARE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int8_t Status_<ContainerAllocator>::RECORD;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace caret_msgs

#endif  // CARET_MSGS__MSG__DETAIL__STATUS__STRUCT_HPP_
