// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from caret_msgs:msg/Status.idl
// generated code does not contain a copyright notice
#include "caret_msgs/msg/detail/status__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `caret_node_name`
// Member `node_names`
#include "rosidl_runtime_c/string_functions.h"

bool
caret_msgs__msg__Status__init(caret_msgs__msg__Status * msg)
{
  if (!msg) {
    return false;
  }
  // caret_node_name
  if (!rosidl_runtime_c__String__init(&msg->caret_node_name)) {
    caret_msgs__msg__Status__fini(msg);
    return false;
  }
  // status
  // node_names
  if (!rosidl_runtime_c__String__Sequence__init(&msg->node_names, 0)) {
    caret_msgs__msg__Status__fini(msg);
    return false;
  }
  // pid
  return true;
}

void
caret_msgs__msg__Status__fini(caret_msgs__msg__Status * msg)
{
  if (!msg) {
    return;
  }
  // caret_node_name
  rosidl_runtime_c__String__fini(&msg->caret_node_name);
  // status
  // node_names
  rosidl_runtime_c__String__Sequence__fini(&msg->node_names);
  // pid
}

bool
caret_msgs__msg__Status__are_equal(const caret_msgs__msg__Status * lhs, const caret_msgs__msg__Status * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // caret_node_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->caret_node_name), &(rhs->caret_node_name)))
  {
    return false;
  }
  // status
  if (lhs->status != rhs->status) {
    return false;
  }
  // node_names
  if (!rosidl_runtime_c__String__Sequence__are_equal(
      &(lhs->node_names), &(rhs->node_names)))
  {
    return false;
  }
  // pid
  if (lhs->pid != rhs->pid) {
    return false;
  }
  return true;
}

bool
caret_msgs__msg__Status__copy(
  const caret_msgs__msg__Status * input,
  caret_msgs__msg__Status * output)
{
  if (!input || !output) {
    return false;
  }
  // caret_node_name
  if (!rosidl_runtime_c__String__copy(
      &(input->caret_node_name), &(output->caret_node_name)))
  {
    return false;
  }
  // status
  output->status = input->status;
  // node_names
  if (!rosidl_runtime_c__String__Sequence__copy(
      &(input->node_names), &(output->node_names)))
  {
    return false;
  }
  // pid
  output->pid = input->pid;
  return true;
}

caret_msgs__msg__Status *
caret_msgs__msg__Status__create()
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  caret_msgs__msg__Status * msg = (caret_msgs__msg__Status *)allocator.allocate(sizeof(caret_msgs__msg__Status), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(caret_msgs__msg__Status));
  bool success = caret_msgs__msg__Status__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
caret_msgs__msg__Status__destroy(caret_msgs__msg__Status * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    caret_msgs__msg__Status__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
caret_msgs__msg__Status__Sequence__init(caret_msgs__msg__Status__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  caret_msgs__msg__Status * data = NULL;

  if (size) {
    data = (caret_msgs__msg__Status *)allocator.zero_allocate(size, sizeof(caret_msgs__msg__Status), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = caret_msgs__msg__Status__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        caret_msgs__msg__Status__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
caret_msgs__msg__Status__Sequence__fini(caret_msgs__msg__Status__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      caret_msgs__msg__Status__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

caret_msgs__msg__Status__Sequence *
caret_msgs__msg__Status__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  caret_msgs__msg__Status__Sequence * array = (caret_msgs__msg__Status__Sequence *)allocator.allocate(sizeof(caret_msgs__msg__Status__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = caret_msgs__msg__Status__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
caret_msgs__msg__Status__Sequence__destroy(caret_msgs__msg__Status__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    caret_msgs__msg__Status__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
caret_msgs__msg__Status__Sequence__are_equal(const caret_msgs__msg__Status__Sequence * lhs, const caret_msgs__msg__Status__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!caret_msgs__msg__Status__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
caret_msgs__msg__Status__Sequence__copy(
  const caret_msgs__msg__Status__Sequence * input,
  caret_msgs__msg__Status__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(caret_msgs__msg__Status);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    caret_msgs__msg__Status * data =
      (caret_msgs__msg__Status *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!caret_msgs__msg__Status__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          caret_msgs__msg__Status__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!caret_msgs__msg__Status__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
